#ifndef DIRECTOR_H
#define DIRECTOR_H
#include "session_common.h"

class Dispatch;

class Director {
 public:
  std::shared_ptr<Dispatch> chain;
  StringFunc to_client;
  StringFunc to_server;
  // void Session::post(notifyFunc nf)
  std::function<void(notifyFunc)> post;

  void client_input(const std::string &input);
  void server_line(const std::string &line, const std::string &raw_line);
  void server_prompt(const std::string &prompt, const std::string &raw_prompt);

  bool active;
  // not sure if I need these or not?
  std::string current_raw_prompt;
  std::string current_prompt;

  std::string old_prompt;
  std::string old_raw_prompt;

  void proxy_activate();
  void proxy_deactivate();

  char game;  // 0 = not in a game

  // not sure on these...  or how I want to use them.
  // maybe this is the place for these?!
  // IF these are public -- Session can access them.  :P
  bool show_client;
  bool talk_direct;

  // maybe these would work better?
  std::function<void(bool)> set_show_client;
  std::function<void(bool)> set_talk_direct;

  Director();
  ~Director();

  void have_input(void);
  void menu_choice(void);
  int count;

  int current_sector;
  
 private:
  StringFunc SL_parser;
  StringFunc SF_cimline, SF_sectorline, SF_portline, SF_warpline;

  void SL_cimline(const std::string &line);
  void SL_thiefline(const std::string &line);
  void SL_sectorline(const std::string &line);
  void SL_portline(const std::string &line);
  void SL_warpline(const std::string &line);
};

#include "dispatchers.h"

#endif